/*
  File name: farread.h
  Copyright: (C) 2005 - 2007 Tomasz Kazmierczak

  Creation date: 27.07.2005
  Last modification date: 28.08.2007

  This file is part of Cytadela

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *

  This part of Cytadela app (farread.cpp and farread.h) is based on "far"
  library which is a library for creating and manipulating far archive files.
  far library copyright: (C) 2002 - 2006 Tomasz Kazmierczak
*/

#ifndef _FARREAD_H_
#define _FARREAD_H_

#include <stdint.h>

//archivised file formats
#define FAR_FMT_UNDET        -1
//images
#define FAR_FMT_TGA           3

//sounds/music
#define FAR_FMT_WAV          10
#define FAR_FMT_MP3          11

class FarHeader {
public:
	uint16_t wFileId;              //file identifier
	uint16_t wFileVer;             //file version
	uint32_t dwFileSize;           //file size
	int32_t  iFilesQuantty;        //number of archivised files
	uint32_t dwReserved1;
	uint32_t dwReserved2;
};

class FarRootEntry {
public:
	uint32_t    dwPackedFileOffset;  //file data offset
	uint32_t    dwPackedFileSize;    //file size
	uint16_t    wFileType;           //file type
	uint16_t    wFileNameLength;     //file name length
	uint32_t    dwReserved1;
	uint32_t    dwReserved2;
};

typedef class tagImgDims {
public:
	uint32_t dwWidth;
	uint32_t dwHeight;
	uint32_t dwSize;
	uint32_t dwBPP;
} ImgDims;

//NOTE: memory pointed by the returned address must be freed by the caller
uint8_t *farReadImgData(char *szFarFileName, char *szFileName, ImgDims &dims);

#endif
